<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<head>
    <title>common</title>
    <link rel="stylesheet" href="../ldoc.css" type="text/css" />
</head>
<body>

<div id="container">

<div id="product">
	<div id="product_logo"></div>
	<div id="product_name"><big><b></b></big></div>
	<div id="product_description"></div>
</div> <!-- id="product" -->


<div id="main">


<!-- Menu -->

<div id="navigation">
<br/>
<h1>mframework</h1>


<h2>Contents</h2>
<ul>
<li><a href="#Functions">Functions</a></li>
</ul>


</ul>

</div>

<div id="content">

<h1>Script <code>Common</code></h1>
<p>

</p>
<p>

<ul>
    <li>Scripts/mFramework/Common.lua ,
    Various Common Methods used throughout mFramework.</li>
</ul>
</p>
    <h3>Info:</h3>
    <ul>
        <li><strong>Author</strong>:  Theros   ~ Discord: Theros#7648, Site: https://svaltek.xyz.</li>
    </ul>


<h2><a href="#Functions">Functions</a></h2>
<table class="function_list">
	<tr>
	<td class="name" nowrap><a href="#string_expand">string_expand (s, subst)</a></td>
	<td class="summary">expand a string containing any <code>${var}</code> or <code>$var</code>.</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#assert_arg">assert_arg (idx, val, tp)</a></td>
	<td class="summary">
<ul>
    <li>bind an argument to a type and throw an error if the provided param doesnt match at runtime.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#import">import (t, T)</a></td>
	<td class="summary">
<ul>
    <li>take a table and 'inject' it into the local namespace.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#MakeCallable">MakeCallable (obj)</a></td>
	<td class="summary">Make an Object Callable.</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#PatchVars">PatchVars (vars)</a></td>
	<td class="summary">Used for patching CVars at runtime.</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#bind_getter">bind_getter (t, k)</a></td>
	<td class="summary">
<ul>
    <li>Create a function that returns the value of t[k] ,
    | The returned function is Bound to the Provided Table,Key.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#bind_setter">bind_setter (t, k)</a></td>
	<td class="summary">
<ul>
    <li>Create a function that sets the value of t[k] ,
    | The returned function is Bound to the Provided Table,Key ,
    | The argument passed to the returned function is used as the value to set.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#getter">getter (t)</a></td>
	<td class="summary">
<ul>
    <li>Create a function that returns the value of t[k] ,
    | The argument passed to the returned function is used as the Key.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#setter">setter (t)</a></td>
	<td class="summary">
<ul>
    <li>Create a function that sets the value of t[k] ,
    | The argument passed to the returned function is used as the Key.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#Exists">Exists (path)</a></td>
	<td class="summary">
<ul>
    <li>Check if a file or directory exists in path ,
    | Path is Relative to Server Root.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#WriteFile">WriteFile (path, data)</a></td>
	<td class="summary">
<ul>
    <li>Write file to Disk</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#ReadFile">ReadFile (path)</a></td>
	<td class="summary">
<ul>
    <li>Read File from Disk</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#findPlayer">findPlayer (search)</a></td>
	<td class="summary">find a player by name or steamId, supports partial matches
| Case Sensitive,  ALLWAYS Verify correct player found.</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#rmiTablePayload">rmiTablePayload (t, parse)</a></td>
	<td class="summary">
<ul>
    <li>rmiTablePayload, used for Serialising tables for use with rmi calls</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#mCustomizeActions">mCustomizeActions (itemClass, customActions, serverHandler)</a></td>
	<td class="summary">
<ul>
    <li>Quickly Initialise and Assign CustomActions for a Item Class.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#mF_eval">mF_eval (eval_string)</a></td>
	<td class="summary">
<ul>
    <li>Evaluate a Lua String
    | evaluates <code>eval_string</code> in Protected mode, Does nothing if the provided string ,
    | contains errors or is not a valid lua chunk</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#_WaitFor">_WaitFor (conf)</a></td>
	<td class="summary">
<ul>
    <li>Wait for something to return true
    | Provided a valid <code>conf</code> definition will wait for the provided function or lua chunck to return true
    | the provided <code>conf</code> table should contain
    |    {
    |        tag = "Give your _waitFor a name/description",
    |        --valid lua code or function call that must return true or nil
    |        check = function() end,
    |        --a function to run when compleated and true
    |        func = function() end
    |    }</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#SerialiseTable">SerialiseTable (t, parse)</a></td>
	<td class="summary">
<ul>
    <li>Serialise a Table and deseriase back again
    | supports basic functions</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#mF_LogRipper">mF_LogRipper (f)</a></td>
	<td class="summary">
<ul>
    <li>Used for Grabbing Data Logged to Console/Logfile from function <code>f</code> ,
    this only grabs the Data Logged During the provdided function call ,
    and returns Raw Log output.</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#Chain">Chain (...)</a></td>
	<td class="summary">
<ul>
    <li>used to chain multiple functions/callbacks
    Example
    local function TimedText (seconds, text)
     return function (go)
         print(text)
         millseconds = (seconds or 1) * 1000
         Script.SetTimerForFunction(millseconds, go)
     end
    end</li>
</ul>
</td>
	</tr>
	<tr>
	<td class="name" nowrap><a href="#RegisterModule">RegisterModule (name, this_module)</a></td>
	<td class="summary">
<ul>
    <li>Registers a Module Table with the Custom Loader
    | returns boolean and a message on error</li>
</ul>
</td>
	</tr>
</table>

<br/>
<br/>


    <h2 class="section-header "><a name="Functions"></a>Functions</h2>

    <dl class="function">
    <dt>
    <a name = "string_expand"></a>
    <strong>string_expand (s, subst)</strong>
    </dt>
    <dd>
    expand a string containing any <code>${var}</code> or <code>$var</code>.
 Substitution values should be only numbers or strings.


    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">s</span>
         string the string
        </li>
        <li><span class="parameter">subst</span>
         any either a table or a function (as in <a href="https://www.lua.org/manual/5.1/manual.html#pdf-string.gsub">string.gsub</a>)
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        string expanded string
    </ol>




</dd>
    <dt>
    <a name = "assert_arg"></a>
    <strong>assert_arg (idx, val, tp)</strong>
    </dt>
    <dd>

<ul>
    <li>bind an argument to a type and throw an error if the provided param doesnt match at runtime.
    Note this works in reverse of the normal assert in that it returns nil if the argumens provided are valid
    if not the it either returns true plus and error message , or if it fails to grab debug info just true.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">idx</span>
         number
 positonal index of the param to bind
        </li>
        <li><span class="parameter">val</span>
         any the param to bind
        </li>
        <li><span class="parameter">tp</span>
         string the params bound type
        </li>
    </ul>




    <h3>Usage:</h3>
    <ul>
        <pre class="example"><span class="keyword">local</span> test = <span class="keyword">function</span>(somearg,str,somearg)
<span class="keyword">if</span> assert_arg(<span class="number">2</span>,str,<span class="string">'string'</span>) <span class="keyword">then</span>
   <span class="keyword">return</span>
<span class="keyword">end</span>

test(<span class="keyword">nil</span>,<span class="number">1</span>,<span class="keyword">nil</span>) -&gt; Invalid Param <span class="keyword">in</span> [test()]&gt; Argument:<span class="number">2</span> Type: number Expected: <span class="global">string</span></pre>
    </ul>

</dd>
    <dt>
    <a name = "import"></a>
    <strong>import (t, T)</strong>
    </dt>
    <dd>

<ul>
    <li>take a table and 'inject' it into the local namespace.
    An optional destination table (defaults to callers environment)</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table
 The Table
        </li>
        <li><span class="parameter">T</span>
          table
        </li>
    </ul>





</dd>
    <dt>
    <a name = "MakeCallable"></a>
    <strong>MakeCallable (obj)</strong>
    </dt>
    <dd>
    Make an Object Callable.


    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">obj</span>



        </li>
    </ul>





</dd>
    <dt>
    <a name = "PatchVars"></a>
    <strong>PatchVars (vars)</strong>
    </dt>
    <dd>
    Used for patching CVars at runtime.


    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">vars</span>



        </li>
    </ul>





</dd>
    <dt>
    <a name = "bind_getter"></a>
    <strong>bind_getter (t, k)</strong>
    </dt>
    <dd>

<ul>
    <li>Create a function that returns the value of t[k] ,
    | The returned function is Bound to the Provided Table,Key.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table      table to access
        </li>
        <li><span class="parameter">k</span>
         any        key to return
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        function returned getter function
    </ol>




</dd>
    <dt>
    <a name = "bind_setter"></a>
    <strong>bind_setter (t, k)</strong>
    </dt>
    <dd>

<ul>
    <li>Create a function that sets the value of t[k] ,
    | The returned function is Bound to the Provided Table,Key ,
    | The argument passed to the returned function is used as the value to set.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table       table to access
        </li>
        <li><span class="parameter">k</span>
         table       key to set
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        function     returned setter function
    </ol>




</dd>
    <dt>
    <a name = "getter"></a>
    <strong>getter (t)</strong>
    </dt>
    <dd>

<ul>
    <li>Create a function that returns the value of t[k] ,
    | The argument passed to the returned function is used as the Key.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table       table to access
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        function     returned getter function
    </ol>




</dd>
    <dt>
    <a name = "setter"></a>
    <strong>setter (t)</strong>
    </dt>
    <dd>

<ul>
    <li>Create a function that sets the value of t[k] ,
    | The argument passed to the returned function is used as the Key.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table       table to access
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        function     returned setter function
    </ol>




</dd>
    <dt>
    <a name = "Exists"></a>
    <strong>Exists (path)</strong>
    </dt>
    <dd>

<ul>
    <li>Check if a file or directory exists in path ,
    | Path is Relative to Server Root.</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">path</span>
         string path - the path to a file or directory to test
        </li>
    </ul>





</dd>
    <dt>
    <a name = "WriteFile"></a>
    <strong>WriteFile (path, data)</strong>
    </dt>
    <dd>

<ul>
    <li>Write file to Disk</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">path</span>
         string       path of file to Write, starts in Server root
        </li>
        <li><span class="parameter">data</span>
         any          File Contents to Write
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        boolean,string   true,nil and a message
    </ol>




</dd>
    <dt>
    <a name = "ReadFile"></a>
    <strong>ReadFile (path)</strong>
    </dt>
    <dd>

<ul>
    <li>Read File from Disk</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">path</span>
         string      path of file to Write, starts in Server root
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        boolean,any     true,nil and file content or message
    </ol>




</dd>
    <dt>
    <a name = "findPlayer"></a>
    <strong>findPlayer (search)</strong>
    </dt>
    <dd>
    find a player by name or steamId, supports partial matches
| Case Sensitive,  ALLWAYS Verify correct player found.
| local player = findPlayer {name = "playerName"}
| local player = findPlayer {steamId = "29483048203948"}


    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">search</span>
         string
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>
        <li>
        table|nil player</li>
        <li>
        string errormsg</li>
    </ol>




</dd>
    <dt>
    <a name = "rmiTablePayload"></a>
    <strong>rmiTablePayload (t, parse)</strong>
    </dt>
    <dd>

<ul>
    <li>rmiTablePayload, used for Serialising tables for use with rmi calls</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         any table or stringPayload to Serialise
        </li>
        <li><span class="parameter">parse</span>
         boolean if true then parse the given string to table or dump table to string when false
        </li>
    </ul>





</dd>
    <dt>
    <a name = "mCustomizeActions"></a>
    <strong>mCustomizeActions (itemClass, customActions, serverHandler)</strong>
    </dt>
    <dd>

<ul>
    <li>Quickly Initialise and Assign CustomActions for a Item Class.
    | Definition table defining your Actions eg <code>{[&quot;ActionName&quot;] = function(self,player,action) --code end}</code>
    | Optional Set <code>serverHandler</code> true to Enable the ServerSide Handler (Callback) for this Item</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">itemClass</span>
         string Item Class your Creating Actions For
        </li>
        <li><span class="parameter">customActions</span>
         table
        </li>
        <li><span class="parameter">serverHandler</span>
         boolean
        </li>
    </ul>





</dd>
    <dt>
    <a name = "mF_eval"></a>
    <strong>mF_eval (eval_string)</strong>
    </dt>
    <dd>

<ul>
    <li>Evaluate a Lua String
    | evaluates <code>eval_string</code> in Protected mode, Does nothing if the provided string ,
    | contains errors or is not a valid lua chunk</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">eval_string</span>
         string
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>
        <li>
        boolean success</li>
        <li>
        any result</li>
    </ol>




</dd>
    <dt>
    <a name = "_WaitFor"></a>
    <strong>_WaitFor (conf)</strong>
    </dt>
    <dd>

<ul>
    <li>Wait for something to return true
    | Provided a valid <code>conf</code> definition will wait for the provided function or lua chunck to return true
    | the provided <code>conf</code> table should contain
    |    {
    |        tag = "Give your _waitFor a name/description",
    |        --valid lua code or function call that must return true or nil
    |        check = function() end,
    |        --a function to run when compleated and true
    |        func = function() end
    |    }</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">conf</span>
         table
        </li>
    </ul>





</dd>
    <dt>
    <a name = "SerialiseTable"></a>
    <strong>SerialiseTable (t, parse)</strong>
    </dt>
    <dd>

<ul>
    <li>Serialise a Table and deseriase back again
    | supports basic functions
    set to true to Deserialise/Parse the provided string
    serialised table as a string OR deserialised string as a table</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">t</span>
         table|string
 input table or string to serialise or deserialise
        </li>
        <li><span class="parameter">parse</span>
         boolean
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        string|table output
    </ol>




</dd>
    <dt>
    <a name = "mF_LogRipper"></a>
    <strong>mF_LogRipper (f)</strong>
    </dt>
    <dd>

<ul>
    <li>Used for Grabbing Data Logged to Console/Logfile from function <code>f</code> ,
    this only grabs the Data Logged During the provdided function call ,
    and returns Raw Log output.
    a function to Rip Log Output from
    any further parameters are passed to your function <code>f(...)</code>
    LogData - A string Containging Raw Captured Log Data</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">f</span>
         function
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        string
    </ol>




</dd>
    <dt>
    <a name = "Chain"></a>
    <strong>Chain (...)</strong>
    </dt>
    <dd>

<ul>
    <li>used to chain multiple functions/callbacks
    Example
    local function TimedText (seconds, text)
     return function (go)
         print(text)
         millseconds = (seconds or 1) * 1000
         Script.SetTimerForFunction(millseconds, go)
     end
    end  Chain(
     TimedText(1, 'fading in'),
     TimedText(1, 'showing splash screen'),
     TimedText(1, 'showing title screen'),
     TimedText(1, 'showing demo')
    )()
    the cretedfunction chain</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">...</span>



        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>

        function chain
    </ol>




</dd>
    <dt>
    <a name = "RegisterModule"></a>
    <strong>RegisterModule (name, this_module)</strong>
    </dt>
    <dd>

<ul>
    <li>Registers a Module Table with the Custom Loader
    | returns boolean and a message on error
    This table Defines your Module, same as you would return in a standard module,</li>
</ul>



    <h3>Parameters:</h3>
    <ul>
        <li><span class="parameter">name</span>
         string Module Name
 This is the Module Name used to Load the Registered Module
        </li>
        <li><span class="parameter">this_module</span>
         table Module Table
        </li>
    </ul>

    <h3>Returns:</h3>
    <ol>
        <li>
        boolean success</li>
        <li>
        string errorMsg</li>
    </ol>




</dd>
</dl>


</div> <!-- id="content" -->
</div> <!-- id="main" -->
<div id="about">
<i>generated by <a href="http://github.com/stevedonovan/LDoc">LDoc 1.4.6</a></i>
<i style="float:right;">Last updated 2020-05-04 19:22:02 </i>
</div> <!-- id="about" -->
</div> <!-- id="container" -->
</body>
</html>
